/**
 * @file usr_str.h
 * @brief 񑀍p̔ėp֐
 */
//---------------------------------------------------------------------------
#ifndef UsrStrH
#define UsrStrH

//---------------------------------------------------------------------------
#include <System.JSON.hpp>

//---------------------------------------------------------------------------
extern bool DebugOut;	//!< fobO񑗏o(Bݒ)

/**
 * @brief fobO񑗏o
 * @details DebugOut=true ̏ꍇAfobO𑗏o܂(OutputDebugString)B
 * @param s 
 */
void OutDebugStr(UnicodeString s);

//---------------------------------------------------------------------------
extern const _TCHAR *null_TCHAR;	//!< 󕶎ւ̃|C^

//---------------------------------------------------------------------------
int __fastcall comp_NaturalOrder(TStringList *List, int Index1, int Index2);	//!< R
int __fastcall comp_AscendOrder(TStringList *List, int Index1, int Index2);		//!< 
int __fastcall comp_DescendOrder(TStringList *List, int Index1, int Index2);	//!< ~
int __fastcall comp_ObjectsOrder(TStringList *List, int Index1, int Index2);	//!< Objects 

//---------------------------------------------------------------------------
#define TXLIMIT_MARK "\x03\x03\x03"	//!< s}[N

extern int  USR_CsvCol;				//!< \[gΏۗ
extern int  USR_CsvSortMode;		//!< \[g[h(1:/ -1~)
extern bool USR_CsvTopIsHdr;		//!< 擪s͍ږ

/**
 * @brief 𐔒lƂĔr
 * @param s1 rΏە1
 * @param s2 rΏە2
 * @retval >0 s1>s2
 * @retval <0 s1<s2
 * @retval 0 s1==s2
 */
int comp_NumStr(UnicodeString s1, UnicodeString s2);

/**
 * @brief TStringList.CustomSort p̔r֐: CSVR
 * @details ΏۂCSVXgƂ݂ȂARŔr܂B@n
 * lƂĔrłȂΕ񏇁AȂ΍sԍ((int)Objects)ɂȂ܂B@n
 * ŕAUSR_CsvColAUSR_CsvSortModeAUSR_CsvTopIsHdr ɊÂčs܂B
 * @sa USR_CsvCol
 * @sa USR_CsvSortMode
 * @sa USR_CsvTopIsHdr
 */
int __fastcall comp_CsvNaturalOrder(TStringList *List, int Index1, int Index2);

/**
 * @brief TStringList.CustomSort p̔r֐: TSVR
 * @details ΏۂTSVXgƂ݂ȂARŔr܂B@n
 * lƂĔrłȂΕ񏇁AȂ΍sԍ((int)Objects)ɂȂ܂B@n
 * ŕAUSR_CsvColAUSR_CsvSortModeAUSR_CsvTopIsHdr ɊÂčs܂B
 * @sa USR_CsvCol
 * @sa USR_CsvSortMode
 * @sa USR_CsvTopIsHdr
 */
int __fastcall comp_TsvNaturalOrder(TStringList *List, int Index1, int Index2);

/** @brief TStringList.CustomSort p̔r֐: TSV */
int __fastcall comp_TsvTextOrder(TStringList *List, int Index1, int Index2);

//---------------------------------------------------------------------------
/**
 * @brief wZp[^̑O̕擾
 * @details * w肵Zp[^̑Oɂ镶擾܂B@n
 * Zp[^Ȃꍇ́Â܂ܕԂ܂B
 * @param s Ώە
 * @param sp Zp[^
 * @return UnicodeString
 */
UnicodeString get_tkn(UnicodeString s, UnicodeString sp);

/**
 * @brief wZp[^̌̕擾
 * @details w肵Zp[^̌ɂ镶擾܂B@n
 * Zp[^Ȃꍇ́AEmptyStr Ԃ܂B
 * @param s Ώە
 * @param sp Zp[^
 * @return UnicodeString
 */
UnicodeString get_tkn_r(UnicodeString s, UnicodeString sp);

/**
 * @brief wZp[^Ԃ̕擾
 * @details w肵̃Zp[^̊Ԃɂ镶擾܂B@n
 * Zp[^2Ȃꍇ́AZp[^1ȍ~̕Ԃ܂B
 * @param s Ώە
 * @param sp1 Zp[^1
 * @param sp2 Zp[^2
 * @return UnicodeString
 */
UnicodeString get_tkn_m(UnicodeString s, UnicodeString sp1, UnicodeString sp2);

/**
 * @brief ^ȗOɂ镶擾
 * @details ^ȗOɂ镶擾܂B^uȂꍇ́Â܂ܕԂ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString get_pre_tab(UnicodeString s);

/**
 * @brief ^ǔɂ镶擾
 * @details ^ǔɂ镶擾܂B^uȂꍇ́AEmptyStr Ԃ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString get_post_tab(UnicodeString s);

/**
 * @brief s1sڂ̓e擾
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString get_first_line(UnicodeString s);

/**
 * @brief 񒆂ɂ銇ʓ (`) ̕擾
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString get_in_paren(UnicodeString s);

/**
 * @brief 񒆂ɂ銇ʓ (`) ̕擾
 * @details 񒆂ɂ銇ʓ (`) ̕擾܂B (`) ̌㑱ɂȂ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString split_in_paren(UnicodeString &s);

/**
 * @brief OɃ^u܂܂Ȃ擾
 * @details OɃ^u܂܂Ȃ擾܂BΏۂs̏ꍇAłȂŏ̕Ԃ܂B
 * @param s Ώە
 * @param trim_sw Ő󔒂␧䕶폜
 * @return UnicodeString
 */
UnicodeString get_norm_str(UnicodeString s, bool trim_sw = false);

/**
 * @brief wZp[^O̕𕪗Ď擾
 * @details w肵Zp[^̑Oɂ镶𕪗Ď擾܂B@n
 * ́AZp[^̌㑱ɂȂ܂B@n
 * Zp[^Ȃꍇ́Â܂ܕԂA͋ɂȂ܂B
 * @param s Ώە
 * @param sp Zp[^
 * @return UnicodeString
 */
UnicodeString split_tkn(UnicodeString &s, UnicodeString sp);

/**
 * @brief 󔒋؂O̕𕪗Ď擾
 * @details 󔒋؂̑OɑOɂ镶𕪗Ď擾܂B@n
 * 擪ɂ󔒂́A؂ƌȂ܂BႦ΁Asplit_tkn_spc("  abc def")  "  abc" Ԃ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString split_tkn_spc(UnicodeString &s);

/**
 * @brief ^uO̕𕪗Ď擾
 * @details ^ȗOɂ镶𕪗Ď擾܂B́A^ǔ㑱ɂȂ܂B@n
 * ^uȂꍇ́Â܂ܕԂA͋ɂȂ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString split_pre_tab(UnicodeString &s);

/**
 * @brief 񂩂(^:`:)𕪗Ď擾
 * @details Ώە̐擪ɂ(^:`:)𕪗Ď擾܂B́Ǎ㑱ɂȂ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString split_dsc(UnicodeString &s);

/**
 * @brief 񂩂擪𕪗Ď擾
 * @details ̐擪ɂ镶𕪗Ď擾܂B́A2ڈȍ~̕ɂȂ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString split_top_ch(UnicodeString &s);

/**
 * @brief 񂩂擪𕪗Ď擾
 * @details ̐擪ɂ镶𕪗Ď擾܂B́A2ڈȍ~̕ɂȂ܂B
 * @param s Ώە
 * @return WideChar
 */
WideChar split_top_wch(UnicodeString &s);

/**
 * @brief R}hCp[^ɕ
 * @details ΏەR}hCƂ݂ȂAp[^̃Xg쐬܂B
 * @param s Ώە
 * @param[out] lst p[^̃Xg
 * @return int
 */
int split_cmd_line(UnicodeString s, TStringList *lst);

/**
 * @brief R}hCt@C𕪗
 * @details ΏەR}hCƂ݂ȂA擪̃t@C𕪗Ď擾܂B@n
 * ́At@Cȍ~̃p[^ɂȂ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString split_file_param(UnicodeString &s);

/**
 * @brief ^uŕzƂĎ擾
 * @param s Ώە
 * @return TStringDynArray
 */
TStringDynArray split_strings_tab(UnicodeString s);

/**
 * @brief Z~RŕzƂĎ擾
 * @param s Ώە
 * @param del_empty EmptyStrO
 * @return TStringDynArray 
 */
TStringDynArray split_strings_semicolon(UnicodeString s, bool del_empty = false);

/**
 * @brief 񂩂猟폜
 * @param s Ώە
 * @param w 
 * @return true 폜
 * @return false 񂪊܂܂ĂȂ
 */
bool remove_text(UnicodeString &s, UnicodeString w);

/**
 * @brief ̐擪Ɍ񂪂폜(召𖳎)
 * @param s Ώە
 * @param w 
 * @return true 擪̌폜
 * @return false 擪Ɍ񂪂Ȃ
 */
bool remove_top_text(UnicodeString &s, UnicodeString w);

/**
 * @brief ̐擪Ɍ񂪂폜(召)
 * @param s Ώە
 * @param w 
 * @return true 擪̌폜
 * @return false 擪Ɍ񂪂Ȃ
 */
bool remove_top_s(UnicodeString &s, UnicodeString w);

/**
 * @brief ̐擪 @ 폜
 * @param s Ώە
 * @return true 擪 @ 폜
 * @return false 擪 @ Ȃ
 */
bool remove_top_AT(UnicodeString &s);

/**
 * @brief ̐擪 $ 폜
 * @param s Ώە
 * @return true 擪 $ 폜
 * @return false 擪 $ Ȃ
 */
bool remove_top_Dollar(UnicodeString &s);

/**
 * @brief ̖Ɍ񂪂폜(召𖳎)
 * @param s Ώە
 * @param w 
 * @return true ̌폜
 * @return false Ɍ񂪂Ȃ
 */
bool remove_end_text(UnicodeString &s, UnicodeString w);

/**
 * @brief ̖Ɍ񂪂폜(召)
 * @param s Ώە
 * @param w 
 * @return true ̌폜
 * @return false Ɍ񂪂Ȃ
 */
bool remove_end_s(UnicodeString &s, UnicodeString w);

/**
 * @brief ̖1폜
 * @param s Ώە
 */
void delete_end(UnicodeString &s);

/**
 * @brief 擪1O擾
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString exclude_top(UnicodeString s);

/**
 * @brief 擪Ɩ̕O擾
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString exclude_top_end(UnicodeString s);

/**
 * @brief Sp󔒂lg~O
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString trim_ex(UnicodeString s);

/**
 * @brief ^ ɂ擪̘A폜u
 * @param s Ώە
 * @param ptn p^[
 * @param rep u
 * @param opt IvV
 * @return UnicodeString 
 */
UnicodeString replace_regex_2(UnicodeString s, UnicodeString ptn, UnicodeString rep, TRegExOptions opt);

/**
 * @brief //Xg( [TAB] u)ɂĕu
 * @param s Ώە
 * @param lst Xg
 * @return UnicodeString 
 */
UnicodeString replace_str_by_list(UnicodeString s, TStringList *lst);

/**
 * @brief ; ؂ŕǉ
 *
 * Ώە񂪋łȂAZ~Rŋ؂ĕǉ܂B
 *
 * @param s Ώە
 * @param t ǉ
 */
void cat_str_semicolon(UnicodeString &s, UnicodeString t);

/**
 * @brief 񂪎w蒷ɂȂ܂Ő擪ɋ󔒂}
 * @param s Ώە
 * @param len ̒
 * @return UnicodeString
 */
UnicodeString ins_spc_length(UnicodeString s, int len);

/**
 * @brief 񂪋ȂftHg擾
 * @param s Ώە
 * @param def ftHg
 * @return UnicodeString 
 */
UnicodeString def_if_empty(UnicodeString s, UnicodeString def);

/**
 * @brief 񂪋łȂȂ؂蕶ǉ
 * @param s Ώە
 * @param sep ؂蕶
 */
void cat_separator(UnicodeString &s, UnicodeString sep);

/**
 * @brief 񂪋łȂȂ؂蕶}āAw蕶ǉ
 * @param s Ώە
 * @param sep ؂蕶
 * @param s2 ǉ
 */
void ins_sep_cat(UnicodeString &s, UnicodeString sep, UnicodeString s2);

/**
 * @brief  NativeInt lɕϊ
 * @param s Ώە
 * @return NativeInt
 */
NativeInt str_to_NativeInt(UnicodeString s);

/**
 * @brief 񂩂琮l𒊏o
 * @param s Ώە
 * @return int
 * @exception sꍇ͗O𑗏o
 */
int extract_int(UnicodeString s);

/**
 * @brief 񂩂琮l𒊏o
 * @details 񂩂琮l𒊏o܂BLȒl擾łȂꍇ́AftHglԂ܂B
 * @param s Ώە
 * @param def ftHgl
 * @return int
 */
int extract_int_def(UnicodeString s, int def = 0);

/**
 * @brief ̐擪琔l̕擾
 * @details ̐擪琔l̕擾܂BJ}͖A+/-AR}ɑΉĂ܂B
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString extract_top_num_str(UnicodeString s);

/**
 * @brief long double l𕶎ɕϊ
 * @param v l
 * @param f_w ̌
 * @return UnicodeString
 */
UnicodeString ldouble_to_str(long double v, int f_w = 3);

/**
 * @brief TCY̐l𕶎ɕϊ(TB܂)
 * @param sz TCY
 * @param dg 
 * @return UnicodeString
 */
UnicodeString get_size_str_T(__int64 sz, int dg);

/**
 * @brief TCY̐l𕶎ɕϊ(GB܂)
 * @param sz TCY
 * @param wd w
 * @param dg 
 * @return UnicodeString
 */
UnicodeString get_size_str_G(__int64 sz, int wd = 10, int dg = 1);

/**
 * @brief TCY̐l𕶎ɕϊ(GB܂)
 * @param sz TCY
 * @param wd w
 * @param dg 
 * @param fmt_mode \[h(0:GB/MB/oCg  1:GB/MB/KB/oCg  2:GB/MB/KB);
 * @return UnicodeString
 */
UnicodeString get_size_str_G(__int64 sz, int wd, int dg, int fmt_mode);

UnicodeString get_size_str_B(__int64 sz, int wd = 14);
UnicodeString get_size_str_C(int sz);
UnicodeString get_size_str_K(SIZE_T sz);

/**
 * @brief RRGGBB`̕ TColor ɕϊ
 * @param s Ώە
 * @return TColor
 */
TColor xRRGGBB_to_col(UnicodeString s);

/**
 * @brief TColor lRRGGBB`̕ɕϊ
 * @param col
 * @return UnicodeString
 */
UnicodeString col_to_xRRGGBB(TColor col);

/**
 * @brief w蕶̈ʒu擾(召𖳎)
 * @param wd 
 * @param s Ώە
 * @return int CfbNX(1x[XAȂꍇ 0)
 */
int pos_i(UnicodeString wd, UnicodeString s);

/**
 * @brief w蕶񂪍ŌɌʒu擾(召)
 * @param wd 
 * @param s Ώە
 * @return int CfbNX(1x[XAȂꍇ 0)
 */
int pos_r(UnicodeString wd, UnicodeString s);

/**
 * @brief w蕶񂪍ŌɌʒu擾(召𖳎)
 * @param wd 
 * @param s Ώە
 * @return int CfbNX(1x[XAȂꍇ 0)
 */
int pos_r_i(UnicodeString wd, UnicodeString s);

/**
 * @brief pOŁAw蕶񂪍ŌɌʒu擾(召)
 * @param wd 
 * @param s Ώە
 * @return int CfbNX(1x[XAȂꍇ 0)
 */
int pos_r_q(UnicodeString wd, UnicodeString s);
int pos_r_q_colon(UnicodeString s);

bool contains_upper(UnicodeString s);

/**
 * @brief Ɍ񂪊܂܂Ă邩H
 * @details ΏەɌ񂪊܂܂Ă邩ǂ𒲂ׂ܂B@n
 * ł́AAND(' ') / OR('|') w肪\łB
 * @param s Ώە
 * @param kwd 
 * @param case_sw 召
 * @return true
 * @return false
 */
bool contains_word_and_or(UnicodeString s, UnicodeString kwd, bool case_sw = false);
bool contains_fuzzy_word(UnicodeString s, UnicodeString kwd, bool case_sw = false, UnicodeString sp = EmptyStr);

/**
 * @brief  | ؂胊XgɊ܂܂Ă邩(召𖳎)?
 * @param lst | ؂胊Xg
 * @param wd 
 * @return true
 * @return false
 */
bool contained_wd_i(UnicodeString lst, UnicodeString wd);

/**
 * @brief Ώە | ؂胊Xǧ܂ł邩(召𖳎)H
 * @param s Ώە
 * @param lst | ؂胊Xg
 * @return true
 * @return false
 */
bool contains_wd_i(UnicodeString s, UnicodeString lst);

/**
 * @brief | ؂胊XgwCfbNX̕擾(召𖳎)
 * @param lst | ؂胊Xg
 * @param idx CfbNX(0x[X)
 * @return UnicodeString
 */
UnicodeString get_word_i_idx(UnicodeString lst, int idx);

/**
 * @brief | ؂胊Xg猟̃CfbNX擾(召𖳎)
 * @param lst | ؂胊Xg
 * @param wd 
 * @return int CfbNX(0x[XAȂꍇ -1)
 */
int idx_of_word_i(UnicodeString lst, UnicodeString wd);

/**
 * @brief  | ؂胊Xgɂ邩H
 * @param w 
 * @param list | ؂胊Xg
 * @return true
 * @return false
 */
bool test_word_i(UnicodeString w, UnicodeString list);

/**
 * @brief ChJ[h܂ރp^[ɂ镶}b`
 * @param ptn p^[
 * @param s Ώە
 * @return true
 * @return false
 */
bool str_match(UnicodeString ptn, UnicodeString s);

/**
 * @brief K\p^[H
 * @param ptn p^[
 * @return true
 * @return false
 */
bool chk_RegExPtn(UnicodeString ptn);

/**
 * @brief ; ؂蕶񂩂琳K\p^[(/`/)𒊏o
 * @param s Ώە(; ؂)
 * @return UnicodeString
 */
UnicodeString extract_prm_RegExPtn(UnicodeString &s);

/**
 * @brief Ɏw蕶/p^[܂܂Ă邩H
 * @param ptn /p^[
 * @param s Ώە
 * @return UnicodeString }b`̕
 */
UnicodeString ptn_match_str(UnicodeString ptn, UnicodeString s);

/**
 * @brief 񂪎w/p^[Ŏn܂Ă邩H
 * @param ptn (/`/ Ȃ琳K\p^[)
 * @param s Ώە
 * @return true
 * @return false
 */
bool starts_ptn(UnicodeString ptn, UnicodeString s);

/**
 * @brief ܂̂߂̐K\p^[擾
 * @param kwd L[[h
 * @param sep_sw \s,\\,/ ؂܂Ȃ
 * @return UnicodeString
 */
UnicodeString get_fuzzy_ptn(UnicodeString kwd, bool sep_sw = false);

/**
 * @brief ꃊXg쐬
 * @param wd Ώە
 * @param[out] lst
 */
void get_find_wd_list(UnicodeString wd, TStringList *lst);

/**
 * @brief ̕ OR/AND 
 * @param wd (̏ꍇ͔p܂͑Sp󔒂ŋ؂)
 * @param s Ώە
 * @param and_sw AND
 * @param not_sw NOT
 * @param case_sw 召
 * @param word_sw PP
 * @return true 
 * @return false 
 */
bool find_mlt(UnicodeString wd, UnicodeString s,
		bool and_sw = false, bool not_sw = false, bool case_sw = false, bool word_sw = false);

/**
 * @brief ̕A}b`̃Xg擾
 * @param wd  (̏ꍇ͔p܂͑Sp󔒂ŋ؂)
 * @param s Ώە
 * @param[out] lst }b`̃Xg
 * @param case_sw 召
 * @return true 
 * @return false 
 */
bool find_mlt_str(UnicodeString wd, UnicodeString s, TStringList *lst, bool case_sw);

/**
 * @brief ̍s擾
 * @param s Ώە
 * @return int s
 */
int get_line_count(UnicodeString s);

/**
 * @brief TStringDynArray ɕǉ
 * @param lst
 * @param s ǉ
 * @param no_dupl ̏ꍇ͒ǉȂ
 */
void add_dyn_array(TStringDynArray &lst, UnicodeString s, bool no_dupl = false);

/**
 * @brief TStringDynArray ̎wCfbNXڂ擾
 * @param items
 * @param idx CfbNX
 * @return UnicodeString
 */
UnicodeString get_array_item(TStringDynArray items, int idx);

/**
 * @brief TStringDynArray ̑Svfw؂蕶pČ
 * @param lst
 * @param sep ؂蕶
 * @return UnicodeString
 */
UnicodeString join_dynarray(TStringDynArray lst, UnicodeString sep);

/**
 * @brief CSV̍ړe TStringDynArray ƂĎ擾
 * @param src Ώە
 * @param size ڐ
 * @param force_size ڐIɐݒ
 * @return TStringDynArray
 */
TStringDynArray get_csv_array(UnicodeString src, int size, bool force_size = false);

/**
 * @brief CSV̍ړe TStringDynArray ƂĎ擾(pl)
 * @param src Ώە
 * @param size ڐ
 * @param del_q pO
 * @return TStringDynArray
 */
TStringDynArray get_csv_array_Q(UnicodeString src, int size, bool del_q = true);

/**
 * @brief CSV񂩂wCfbNX̍ڂ擾
 * @param src Ώە
 * @param idx CfbNX
 * @return UnicodeString
 */
UnicodeString get_csv_item(UnicodeString src, int idx);

/**
 * @brief TSV񂩂wCfbNX̍ڂ擾
 * @param src Ώە
 * @param idx CfbNX
 * @return UnicodeString
 */
UnicodeString get_tsv_item(UnicodeString src, int idx);

/**
 * @brief CSVڂ쐬
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString make_csv_str(UnicodeString s);

/**
 * @brief bool lCSVڂ쐬
 * @param sw
 * @return UnicodeString
 */
UnicodeString make_csv_str(bool sw);

/**
 * @brief TStringDynArray CSV쐬
 * @param lst
 * @return UnicodeString
 */
UnicodeString make_csv_rec_str(TStringDynArray lst);
UnicodeString make_csv_rec_str(std::initializer_list<UnicodeString> lst);

/**
 * @brief CSVXgAwCfbNX̍ڂɈvsCfbNX擾
 * @param lst CSVXg
 * @param s 
 * @param p CfbNX
 * @return int
 */
int indexof_csv_list(TStringList *lst, UnicodeString s, int p);

/**
 * @brief CSṼXg p Ԗڂ̍ڂ s ̃R[h擾
 * @param lst CSVXg
 * @param s 
 * @param p CfbNX
 * @param size TCY
 * @return TStringDynArray
 */
TStringDynArray record_of_csv_list(TStringList *lst, UnicodeString s, int p, int size);

/**
 * @brief GXP[vV[PX̕ϊ
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString conv_esc_char(UnicodeString s);

/**
 * @brief \\  / ɒu
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString yen_to_slash(UnicodeString s);

/**
 * @brief /  \\ ɒu
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString slash_to_yen(UnicodeString s);

/**
 * @brief SHA-1 7̒Zk`ɕϊ
 * @param s ΏۃnbV
 * @return UnicodeString
 */
UnicodeString sha1_to_short(UnicodeString s);

/**
 * @brief  "1" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_1(UnicodeString s);

/**
 * @brief  "0" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_0(UnicodeString s);

/**
 * @brief  "ENTER" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_ENTER(UnicodeString s);

/**
 * @brief  "ESC" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_ESC(UnicodeString s);

/**
 * @brief  "TAB" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_TAB(UnicodeString s);

/**
 * @brief  "DEL" H
 *
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_DEL(UnicodeString s);

/**
 * @brief  "LEFT" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_LEFT(UnicodeString s);

/**
 * @brief  "RIGHT" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_RIGHT(UnicodeString s);

/**
 * @brief  "UP" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_UP(UnicodeString s);

/**
 * @brief  "DOWN" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_DOWN(UnicodeString s);

/**
 * @brief  "HOME" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_HOME(UnicodeString s);

/**
 * @brief  "END" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_END(UnicodeString s);

/**
 * @brief  "F1" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_F1(UnicodeString s);

/**
 * @brief  "F5" H
 * @param s Ώە
 * @return true
 * @return false
 */
bool equal_F5(UnicodeString s);

/**
 * @brief ̓Zp[^("-")H
 * @param s Ώە
 * @return true
 * @return false
 */
bool is_separator(UnicodeString s);

/**
 * @brief p񂩁H
 * @param s Ώە 
 * @return true 
 * @return false 
 */
bool is_alnum_str(UnicodeString s);

/**
 * @brief pPꂩH
 * @param s Ώە
 * @param p ʒu
 * @param len 
 * @return true 
 * @return false 
 */
bool is_word(UnicodeString s, int p, int len);

/**
 * @brief ̐擪w蕶XĝꂩɈv邩H
 * @param lst Xg
 * @param s Ώە
 * @return true
 * @return false
 */
bool starts_tchs(UnicodeString lst, UnicodeString s);

/**
 * @brief ̖w蕶XĝꂩɈv邩H
 * @param lst Xg
 * @param s Ώە
 * @return true
 * @return false
 */
bool ends_tchs(UnicodeString lst, UnicodeString s);

/**
 * @brief  @ Ŏn܂Ă邩 ?
 * @param s Ώە
 * @return true
 * @return false
 */
bool starts_AT(UnicodeString s);

/**
 * @brief  $ Ŏn܂Ă邩 ?
 * @param s Ώە
 * @return true
 * @return false
 */
bool starts_Dollar(UnicodeString s);

/**
 * @brief ̖ \ H
 * @param s Ώە
 * @return true
 * @return false
 */
bool ends_PathDlmtr(UnicodeString s);

/**
 * @brief  \ ܂܂Ă邩H
 * @param s Ώە
 * @return true
 * @return false
 */
bool contains_PathDlmtr(UnicodeString s);

/**
 * @brief  / ܂܂Ă邩H
 * @param s Ώە
 * @return true
 * @return false
 */
bool contains_Slash(UnicodeString s);

/**
 * @brief Ɋ܂܂Ă \ ̌擾
 * @param s Ώە
 * @return int
 */
int  count_PathDlmtr(UnicodeString s);

/**
 * @brief ͐K\(/`/)H
 * @param s Ώە
 * @return true
 * @return false
 */
bool is_regex_slash(UnicodeString s);

/**
 * @brief 񂪈pň͂܂Ă邩H
 * @param s Ώە
 * @return true
 * @return false
 */
bool is_quot(UnicodeString s);

/**
 * @brief 񂪋󔒂܂łpň͂
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString add_quot_if_spc(UnicodeString s);

/**
 * @brief ̈pO
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString exclude_quot(UnicodeString s);

/**
 * @brief TStringList Vlues[name] ̐l擾
 * @param lst ΏۃXg
 * @param name O
 * @param def ftHgl 
 * @return int 
 */
int  get_ListIntVal(TStringList *lst, UnicodeString name, int def = 0);

/**
 * @brief TStringList Vlues[name] 󂩁H
 * @param lst ΏۃXg
 * @param name O
 * @return true 
 * @return false 
 */
bool ListVal_is_empty(TStringList *lst, UnicodeString name);

/**
 * @brief TStringList Vlues[name]=="1"?
 * @param lst ΏۃXg
 * @param name O
 * @return true 
 * @return false 
 */
bool ListVal_equal_1(TStringList *lst, UnicodeString name);

/**
 * @brief 𗚗ƂďdȂŃXgǉ
 * @param[in,out] lst Xg
 * @param s ǉ
 */
void add_as_history(TStrings *lst, UnicodeString s);

/**
 * @brief mbԕɕϊ
 * @param ms ~bl
 * @param cs 1/100b\
 * @return UnicodeString
 */
UnicodeString __fastcall mSecToTStr(unsigned int ms, bool cs = true);

/**
 * @brief p[^(S/M/H܂)mblɕϊ
 * @param prm p[^
 * @return int
 */
int param_to_mSec(UnicodeString prm);

/**
 * @brief ̕\擾
 * @param cv LoX
 * @param s Ώە
 * @param spc_sw /Sp󔒂̑֕l
 * @return int \
 */
int get_TextWidth(TCanvas *cv, UnicodeString s, bool spc_sw = false);

int get_CharWidth(TCanvas *cv, int n, int mgn = 0);

/**
 * @brief TPanel ł̕񕝂擾
 * @param s Ώە 
 * @param pp pl
 * @param d2d_sw Direct2D Ŏ擾
 * @return int 
 */
int get_WidthInPanel(UnicodeString s, TPanel *pp, bool d2d_sw = false);

/**
 * @brief pZ̕񒷂擾
 * @param s Ώە
 * @return int
 */
int str_len_half(UnicodeString s);

/**
 * @brief TQ[gyAlĕ擾
 * @param s Ώە
 * @return int
 */
int str_len_unicode(UnicodeString s);

/**
 * @brief pZ̍ő啝XV
 * @param[o] w ő啝
 * @param s Ώە
 */
void max_len_half(int &w, UnicodeString s);

/**
 * @brief w蕝(pP)ŕ񂪉ElɂȂ悤ɋ󔒂}
 * @param s Ώە
 * @param wd 
 * @param post_s ǉ
 * @return UnicodeString
 */
UnicodeString align_r_str(UnicodeString s, int wd, UnicodeString post_s = EmptyStr);

/**
 * @brief w蕝(pP)ŕ񂪍lɂȂ悤ɋ󔒂}
 * @param s Ώە
 * @param wd 
 * @param post_s ǉ
 * @return UnicodeString
 */
UnicodeString align_l_str(UnicodeString s, int wd, UnicodeString post_s = EmptyStr);

/**
 * @brief 񂪎w蕝Ɏ܂悤ɒ
 * @param s Ώە
 * @param cv 
 * @param wd 
 * @param omit_end ȗ (false: Ԃȗ)
 * @param spc_sw /Sp󔒂̑֕l
 * @return UnicodeString 
 */
UnicodeString minimize_str(UnicodeString s, TCanvas *cv, int wd, bool omit_end = false, bool spc_sw = false);

/**
 * @brief 񂪎w蕝ɂȂ悤ɏȗ/󔒒ǉ
 * @param s Ώە
 * @param cv
 * @param wd 
 * @param omit_end ȗ(false ̏ꍇ͒Ԃȗ)
 * @return UnicodeString
 */
UnicodeString fit_str(UnicodeString s, TCanvas *cv, int wd, bool omit_end = false);

/**
 * @brief //Sp/pϊ
 * @param s Ώە
 * @param to_w Spɕϊ
 * @return UnicodeString
 */
UnicodeString to_Full_or_Half(UnicodeString s, bool to_w);

/**
 * @brief Spɕϊ
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString to_FullWidth(UnicodeString s);

/**
 * @brief pɕϊ
 * @param s Ώە
 * @return UnicodeString
 */
UnicodeString to_HalfWidth(UnicodeString s);

/**
 * @brief ^u󔒂ɕϊ(tHgp)
 * @param s Ώە
 * @param cv
 * @return UnicodeString
 */
UnicodeString cv_TabToSpc(UnicodeString s, TCanvas *cv);

/**
 * @brief ͌rsH
 * @param s Ώە
 * @return int
 */
int is_RuledLine(UnicodeString s);

/**
 * @brief rs擾
 * @param cnt ubN
 * @param ... ubN
 * @return UnicodeString
 */
UnicodeString make_RuledLine(int cnt, ...);

/**
 * @brief AhX擾
 * @param adr AhXl
 * @param w \
 * @return UnicodeString
 */
UnicodeString get_AddrStr(__int64 adr, int w = 0);

/**
 * @brief AXyNg䕶擾
 * @param w 
 * @param h 
 * @return UnicodeString
 */
UnicodeString get_AspectStr(int w, int h);

/**
 * @brief Zbg擾
 * @param charset
 * @return UnicodeString
 */
UnicodeString get_NameOfCharSet(int charset);

/**
 * @brief ̃EGCg擾
 * @param w
 * @return UnicodeString
 */
UnicodeString get_NameOfWeight(int w);

extern const UnicodeString CodePageList;	//!< R[hy[WXg
extern const UnicodeString CodePageListX;	//!< R[hy[WXg

/**
 * @brief R[hy[W̖O擾
 * @param code_page R[hy[W
 * @param long_sw O
 * @param has_bom BOM̗L
 * @return UnicodeString
 */
UnicodeString get_NameOfCodePage(int code_page, bool long_sw = false, bool has_bom = false);

/**
 * @brief w肵ÕR[hy[W擾
 * @param code_name O
 * @return int
 */
int get_CodePageOfName(UnicodeString code_name);

/**
 * @brief UnicodeubN擾
 * @param code 
 * @return UnicodeString 
 */
UnicodeString get_UnicodeBlockName(int code);

/**
 * @brief 񂩂琳K\p^[ɊÂăjR[h|Cg𒊏o
 * @param s 
 * @param ptn 
 * @param dec_sw 
 * @return int 
 */
int extract_UnicodePoint(UnicodeString &s, UnicodeString ptn, bool dec_sw = false);

/**
 * @brief jR[h|Cg𕶎ɕϊ
 * @param uc jR[h|Cg
 * @return UnicodeString 
 */
UnicodeString UnicodePointToStr(int uc);

/**
 * @brief TQ[gyAjR[h|Cgɕϊ
 * @param c 
 * @return int jR[h|Cg
 */
int SurrogateToUnicodePoint(UnicodeString c);

/**
 * @brief ̎QƂ琔lQƂ
 * @param s 
 * @return UnicodeString 
 */
UnicodeString ChEntRef_to_NumChRef(UnicodeString s);

/**
 * @brief UTF8ƂēK؂
 * @param bp `FbNΏ
 * @param size TCY
 * @return int
 */
int check_UTF8(BYTE *bp, int size);

/**
 * @brief Xg[̃R[hy[W擾
 * @param ms
 * @param has_bom
 * @return int R[hy[W(0:s/ -1:oCi)
 */
int  get_MemoryCodePage(TMemoryStream *ms, bool *has_bom = NULL);

/**
 * @brief Xg[̃R[hy[W𔻒肵ƂĎ擾
 * @param ms Xg[
 * @return UnicodeString
 */
UnicodeString get_MemoryStrins(TMemoryStream *ms);

/**
 * @brief TQ[gyA`FbN
 * @param s
 * @return UnicodeString 󔒋؂ŘAĂ܂BȂ EmptyStr
 */
UnicodeString check_Surrogates(UnicodeString s);

/**
 * @brief ˑ([}A͂ݕAPʋLAȂ)`FbN
 * @param s
 * @return UnicodeString 󔒋؂ŘAĕԂ܂BȂ EmptyStr
 */
UnicodeString check_EnvDepandChars(UnicodeString s);

/**
 * @brief Wꂽ[xV^C擾(őr=256)
 * @param s1 Ώە1
 * @param s2 Ώە2
 * @param ig_case 召𖳎
 * @param ig_num 𖳎
 * @param ig_fh Sp/p𖳎
 * @return int (0`1000)
 */
int get_NrmLevenshteinDistance(UnicodeString s1, UnicodeString s2,
	bool ig_case = false, bool ig_num = false, bool ig_fh = false);

UnicodeString get_JsonValStr(TJSONValue *val);

/**
 * @brief JSON̐`
 * @param val 
 * @param[out] lst 
 * @param lvl 
 */
void format_Json(TJSONValue *val, TStringList *lst, int lvl = 0);

UnicodeString decode_TxtVal(UnicodeString s, bool with_q = false);

UnicodeString conv_DfmText(UnicodeString s);

/**
 * @brief .dfm t@C̕fR[h
 * @param[in,out] txt_lst 
 */
void conv_DfmText(TStringList *txt_lst);

/**
 * @brief CfbNX烁j[pANZ[^쐬
 * @param idx CfbNXԍ
 * @param alp_sw A`Zgp(false: 1`9,0 ̂)
 * @return UnicodeString 
 */
UnicodeString make_MenuAccStr(int idx, bool alp_sw = false);

/**
 * @brief ̃At@xbg擾
 * @param s Ώە 
 * @return UnicodeString 
 */
UnicodeString get_NextAlStr(UnicodeString s);

/**
 * @brief  TDateTime ɕϊ
 * @param ts Ώە
 * @param sw_dt tɕϊ
 * @return TDateTime 
 * @exception ϊłȂꍇO𑗏o
 */
TDateTime str_to_DateTime(UnicodeString ts, bool sw_dt = false);
//---------------------------------------------------------------------------
#endif
