/**
 * @file check_thread.h
 * @brief UNCpX̑݃`FbNEXbh
 */
//---------------------------------------------------------------------------
#ifndef TCheckPathThreadH
#define TCheckPathThreadH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>

//---------------------------------------------------------------------------
/**
 * @brief UNCpX̑݃`FbNEXbh
 */
class TCheckPathThread : public TThread
{
private:
	void __fastcall Execute();

	TMultiReadExclusiveWriteSynchronizer *TaskRWLock;

	//XbhZ[tlvpeB
	UnicodeString FPathName;
	UnicodeString __fastcall GetPathName()
	{
		TaskRWLock->BeginRead();
		UnicodeString v = FPathName;
		TaskRWLock->EndRead();
		return v;
	}
	void __fastcall SetPathName(UnicodeString Value)
	{
		TaskRWLock->BeginWrite();
		FPathName = Value;
		TaskRWLock->EndWrite();
	}

public:
	__property UnicodeString PathName = {read = GetPathName,  write = SetPathName};

	bool isOk;
	UnicodeString ErrMsg;
	unsigned int  ErrCode;

	__fastcall TCheckPathThread(bool CreateSuspended);
};
//---------------------------------------------------------------------------
#endif
